// test_waitinline.cpp
// Glenn G. Chappell
// 5 Nov 2013
//
// For CS 202 Fall 2013
// Test program for class template WaitInLine

#include "waitinline.h"  // For class template WaitInLine
#include "waitinline.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;


bool allGood = true;  // true if all tests pass so far


// testWaitInLine_int
// Test for class WaitInLine: int values
// Prints results of tests, sets global allGood to false if any fail
void testWaitInLine_int()
{
    cout << endl;
    cout << "Test: int values" << endl;

    WaitInLine<int> w;

    {
    const WaitInLine<int> & wc(w);
    bool e = wc.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }

    w.put(42);

    {
    bool e = w.empty();
    cout << "Should be nonempty: " << (e ? "EMPTY" : "nonempty") << endl;
    if (e)
        allGood = false;
    }

    {
    int i = w.get();
    cout << "Get - should be 42: " << i << endl;
    if (i != 42)
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }

    w.put(1);
    w.put(2);
    w.put(3);
    w.put(4);

    {
    int i = w.get();
    cout << "Get - should be 1: " << i << endl;
    if (i != 1)
        allGood = false;
    }

    {
    int i = w.get();
    cout << "Get - should be 2: " << i << endl;
    if (i != 2)
        allGood = false;
    }

    {
    int i = w.get();
    cout << "Get - should be 3: " << i << endl;
    if (i != 3)
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be nonempty: " << (e ? "EMPTY" : "nonempty") << endl;
    if (e)
        allGood = false;
    }

    {
    int i = w.get();
    cout << "Get - should be 4: " << i << endl;
    if (i != 4)
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }
}


// testWaitInLine_string
// Test for class WaitInLine: string values
// Prints results of tests, sets global allGood to false if any fail
void testWaitInLine_string()
{
    cout << endl;
    cout << "Test: string values" << endl;

    WaitInLine<string> w;

    {
    const WaitInLine<string> & wc(w);
    bool e = wc.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }

    w.put("abc");

    {
    bool e = w.empty();
    cout << "Should be nonempty: " << (e ? "EMPTY" : "nonempty") << endl;
    if (e)
        allGood = false;
    }

    {
    string i = w.get();
    cout << "Get - should be \"abc\": \"" << i << "\"" << endl;
    if (i != "abc")
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }

    w.put("def");
    w.put("zz");
    w.put("nebulosity");
    w.put("q");

    {
    string i = w.get();
    cout << "Get - should be \"def\": \"" << i << "\"" << endl;
    if (i != "def")
        allGood = false;
    }

    {
    string i = w.get();
    cout << "Get - should be \"zz\": \"" << i << "\"" << endl;
    if (i != "zz")
        allGood = false;
    }

    {
    string i = w.get();
    cout << "Get - should be \"nebulosity\": \"" << i << "\"" << endl;
    if (i != "nebulosity")
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be nonempty: " << (e ? "EMPTY" : "nonempty") << endl;
    if (e)
        allGood = false;
    }

    {
    string i = w.get();
    cout << "Get - should be \"q\": \"" << i << "\"" << endl;
    if (i != "q")
        allGood = false;
    }

    {
    bool e = w.empty();
    cout << "Should be empty: " << (e ? "empty" : "NONEMPTY") << endl;
    if (!e)
        allGood = false;
    }
}


// main program
// Runs tests for class WaitInLine, prints results
int main()
{
    testWaitInLine_int();
    testWaitInLine_string();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

